#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "week2_common.h"

/*
Another short exercise. For the record, the main reason memcpy is faster is simply
because it can copy more data at a time.

That should imply that the relative speed gain is greater the fewer bytes per data type.

As a final aside, I think the compiler op
*/

int main(void) {

    int n = 1e7;
    clock_t start, for_timer, memcpy_timer;
    double *source, *target;

    source = (double *)malloc(n * sizeof(double));
    target = (double *)malloc(n * sizeof(double));

    start = clock();
    for (int i = 0; i < n; i ++) target[i] = source[i];
    for_timer = clock() - start;
    free(source);

    source = (double *) malloc(n * sizeof(double));
    start = clock();
    memcpy(target, source, n * sizeof(double));
    memcpy_timer = clock() - start;

    printf("Time elapsed copying via for loop: %lu ms.\n", CLOCKS_TO_MILLISEC(for_timer));
    printf("Time elapsed copying via memcpy: %lu ms.\n", CLOCKS_TO_MILLISEC(memcpy_timer));

    free(source);
    free(target);

}